from ctypes import *
from secg40 import *
import sys
import time

device = SECG40()


def printLeads():
    if 0 != device.GetOutputLead(OutputLead_E.Lead_RA.value):
        print(OutputLead_E.Lead_RA.name, '  ON')
    else:
        print(OutputLead_E.Lead_RA.name, '  OFF')

    if 0 != device.GetOutputLead(OutputLead_E.Lead_LA.value):
        print(OutputLead_E.Lead_LA.name, '  ON')
    else:
        print(OutputLead_E.Lead_LA.name, '  OFF')

    if 0 != device.GetOutputLead(OutputLead_E.Lead_LL.value):
        print(OutputLead_E.Lead_LL.name, '  ON')
    else:
        print(OutputLead_E.Lead_LL.name, '  OFF')


def testprocedure():
    for lead in range(0, 3):  # Loop RA/LA/LL
        print('### Test Iteration: ', lead, '###')

        # Reset All Setting to Default
        device.ResetSECG_AllLeadOff()

        # Set Output Lead
        if 0 != device.SetOutputLead(lead, 1):
            print('SetOutputLead(', lead, '1) failed')
            return -1
        printLeads()

        # Set Output Function
        outFunc = lead + 1
        if 0 != device.SetOutputFunc(outFunc):
            print('SetOutputFunc(', outFunc, ' 1) failed')
            return -1
        print('Output Function: ', OutputFunction_E(outFunc).name)

        # Set Amplitude : 0.5 / 1.0 / 1.5 mV
        amp = c_double(outFunc * 0.5)
        if 0 != device.SetAmplitude(amp):
            print('SetAmplitude(', amp, ') failed')
            return -1
        print('Amplitude is: ', device.GetAmplitude(), ' mV')

        # Set Frequency : 1.0 / 2.0 / 3.0 Hz
        freq = c_double(outFunc)
        if 0 != device.SetFrequency(freq):
            print('SetFrequency(', freq, ') failed')
            return -1
        print('Frequency is: ', device.GetFrequency(), ' Hz')

        print('---------------------- Output Signal for 5 seconds ------------------------')
        time.sleep(5)


if 0 == device.InitSECG():
    print('InitSECG failed!')
else:
    print('--- InitSECG succeeded! ---')
    testprocedure()
